//////////////////////////////////////////////////////////////
//                                                          //
// MyChat Client SDK, version 2.1 from 27.02.2010           //
// Copyright(c) Alexey Pikurov / Network Software Solutions //
// hobit@nsoft-s.com                                        //
// http://www.nsoft-s.com                                   //
//                                                          //
//////////////////////////////////////////////////////////////
//                                                          //
//                  !                     //
//                                                          //
//////////////////////////////////////////////////////////////
unit mcplugin_func;

interface
uses Windows;
const
  pluginAPIVersionMajor = 2;
  pluginAPIVersionMinor = 1;
  CR=#11;
  CRLF=#13#10;
  terminator=#149; // -

type
//    . uid -   , msg -  
  TmcSendMessageToTextChannel = procedure(uid:dword;msg:PChar);stdcall;
//    , uin - , msg -   
  TmcSendPrivateMessage       = procedure(uin:dword;msg:PChar);stdcall;
//   , ..   ,    
// uin - , uid -  , msg -  
  TmcSendPersonalMessage      = procedure(uin,uid:dword;msg:PChar);stdcall;
//    , ..   ,    
//         
// uin - , uid -  , msg -  
  TmcSendAlertMessage         = procedure(uin,uid:dword;msg:PChar);stdcall;
//   .            
// uid -  , topic -   
  TmcChangeTextChannelTopic   = procedure(uid:dword;topic:PChar);stdcall;
//   ().
// uin -    ,
// uid -  ,     ,
// bantime -  : 1 - 5 , 2 - 15 , 3 - , 4-  , 5 - , 6 - , 7 - , 8 - ;
// bantype -  : 0 -     , 1 -     ("");
// reason -  .
//          
  TmcAdmBanUser               = procedure(uin, uid, bantime, bantype:dword;reason:PChar);stdcall;
//    , uin -  , uid -  .
//             
  TmcAdmKickUser              = procedure(uin, uid:dword);stdcall;
//    . uin -  .
//        
  TmcAdmKillUser              = procedure(uin:dword);stdcall;
//  IP  . uin -  .
//      IP  
  TmcAdmBlockIP               = procedure(uin:dword;reason:PChar);stdcall;
//  MAC    . uin -  
//      MAC  
  TmcAdmBlockMAC              = procedure(uin:dword;reason:PChar);stdcall;
//       .   
//  .        
//     MyChat    .
//   : mcSendRawData(10,'MyPlugin','test message');
// RAW-        ,
//    -.
// uin -  -,
// pluginname -  ,   
// "test message" -  ,    
  TmcSendRawData              = procedure(uin:dword;pluginname,msg:PChar);stdcall;
// ,  mcSendRawData,   -    , 
//  ,       uid
// uid -  ,
// pluginname -  ,   
// "test message" -  ,    
  TmcSendRawDataToChannel     = procedure(uid:dword;pluginname,msg:PChar);stdcall;
//    .     :
// n_groups#group_1#n_users#user_1#user_2#....user_n#group_2#.........
// n_groups -  ,
// # - ,  terminator,
// n_users -     ,
// user_x -   ,  : uin#avatar#nick#sex#
// uin -  , ,
// avatar -   ,
// nick -  ,
// sex -  :  - 1,  - 2,   - 0,
// # - ,  terminator
//     -    
// P.S.      get_next_st
  TmcGetContactsList          = function:PChar;stdcall;
  TmcGetChannelUsersList      = function(uid:dword):PChar;stdcall;
  TmcGetChannelsList          = function:PChar;stdcall;
  TmcGetActivePrivate         = function:DWORD;stdcall;
  TmcGetActiveChannel         = function:DWORD;stdcall;
  TmcClearTextChannel         = procedure(uid:dword);stdcall;
  TmcClearTextPrivate         = procedure(uin:dword);stdcall;
  TmcConsoleCommand           = procedure(scmd:PChar);stdcall;
  TmcLoadOptions              = procedure(fname:PChar);stdcall;

  TmcGetUserQuickInfo         = function(uin:dword):PChar;stdcall;
  TmcGetUserFullInfo          = function(uin:dword):DWORD;stdcall;
  TmcIsTextChannelOpen        = function(uid:dword):DWORD;stdcall;
  TmcIsPrivateOpen            = function(uin:dword):DWORD;stdcall;
  TmcGetChannelName           = function(uid:dword):PChar;stdcall;
  TmcGetMyStatus              = function:DWORD;stdcall;
  TmcIsConnected              = function:DWORD;stdcall;
  TmcGetSmileCode             = function(stsmile, stsmilepack:PChar):PChar;stdcall;
  TmcSelectChannel            = function(uid:DWORD):DWORD;stdcall;
  TmcSelectPrivate            = function(uin:DWORD):DWORD;stdcall;
  TmcSelectConsole            = procedure;stdcall;
  TmcIsPluginLoaded           = function(pluginname:PChar):DWORD;stdcall;
  TmcGetUserActiveCaption     = procedure(uin:DWORD);stdcall;
var
  mcSendMessageToTextChannel : TmcSendMessageToTextChannel;
  mcSendPrivateMessage       : TmcSendPrivateMessage;
  mcSendPersonalMessage      : TmcSendPersonalMessage;
  mcSendAlertMessage         : TmcSendAlertMessage;
  mcChangeTextChannelTopic   : TmcChangeTextChannelTopic;
  mcAdmBanUser               : TmcAdmBanUser;
  mcAdmKickUser              : TmcAdmKickUser;
  mcAdmKillUser              : TmcAdmKillUser;
  mcAdmBlockIP               : TmcAdmBlockIP;
  mcAdmBlockMAC              : TmcAdmBlockMAC;
  mcSendRawData              : TmcSendRawData;
  mcSendRawDataToChannel     : TmcSendRawDataToChannel;
  mcGetContactsList          : TmcGetContactsList;
  mcGetChannelUsersList      : TmcGetChannelUsersList;
  mcGetChannelsList          : TmcGetChannelsList;
  mcGetAtivePrivate          : TmcGetActivePrivate;
  mcGetActiveChannel         : TmcGetActiveChannel;
  mcClearTextChannel         : TmcClearTextChannel;
  mcClearTextPrivate         : TmcClearTextPrivate;
  mcConsoleCommand           : TmcConsoleCommand;
  mcLoadOptions              : TmcLoadOptions;

  mcGetUserQuickInfo         : TmcGetUserQuickInfo;
  mcGetUserFullInfo          : TmcGetUserFullInfo;
  mcIsTextChannelOpen        : TmcIsTextChannelOpen;
  mcIsPrivateOpen            : TmcIsPrivateOpen;
  mcGetChannelName           : TmcGetChannelName;
  mcGetMyStatus              : TmcGetMyStatus;
  mcIsConnected              : TmcIsConnected;
  mcGetSmileCode             : TmcGetSmileCode;
  mcSelectChannel            : TmcSelectChannel;
  mcSelectPrivate            : TmcSelectPrivate;
  mcSelectConsole            : TmcSelectConsole;
  mcIsPluginLoaded           : TmcIsPluginLoaded;
  mcGetUserActiveCaption     : TmcGetUserActiveCaption;

//      ,   ,  
function get_next_st(var st_parse:string;divide_st:string):string;
function mcPluginName:PChar;stdcall;
function mcPluginCopyright:PChar;stdcall;
procedure mcPluginAPIVersionUsed(var vmajor, vminor:dword);stdcall;
function mcPluginVersion:PChar;stdcall;
function mcPluginReleaseDate:PChar;stdcall;
function mcPluginIsOptionsPresent:dword;stdcall;
function mcPluginIsWindowPresent:dword;stdcall;
function mcPluginIsPopupMenuContactsPanelPresent:dword;stdcall;
function mcPluginIsPopupMenuUserInChannelTextPresent:dword;stdcall;
function mcPluginIsPopupMenuUserInChannelUsersListPresent:dword;stdcall;
function mcPluginIsPopupMenuPrivatePresent:dword;stdcall;
function mcPluginIsTopMenuPrivatePresent:dword;stdcall;
function mcPluginWWW:PChar;stdcall;
function mcPluginEmail:PChar;stdcall;
function mcPluginDescription:PChar;stdcall;
function mcPluginHookChannelMessages:dword;stdcall;
function mcPluginHookPrivateMessages:dword;stdcall;
function mcPluginHookPersonalMessages:dword;stdcall;
function mcPluginHookAlertMessages:dword;stdcall;
procedure SetCallBackSendMessageToTextChannel(approc:TmcSendMessageToTextChannel);stdcall;
procedure SetCallBackSendPrivateMessage(approc:TmcSendPrivateMessage);stdcall;
procedure SetCallBackSendPersonalMessage(approc:TmcSendPersonalMessage);stdcall;
procedure SetCallBackSendAlertMessage(approc:TmcSendAlertMessage);stdcall;
procedure SetCallBackChangeTextChannelTopic(approc:TmcChangeTextChannelTopic);stdcall;
procedure SetCallBackAdmBanUser(approc:TmcAdmBanUser);stdcall;
procedure SetCallBackAdmKickUser(approc:TmcAdmKickUser);stdcall;
procedure SetCallBackAdmKillUser(approc:TmcAdmKillUser);stdcall;
procedure SetCallBackAdmBlockIP(approc:TmcAdmBlockIP);stdcall;
procedure SetCallBackAdmBlockMAC(approc:TmcAdmBlockMAC);stdcall;
procedure SetCallBackSendRawData(approc:TmcSendRawData);stdcall;
procedure SetCallBackSendRawDataToChannel(approc:TmcSendRawDataToChannel);stdcall;
procedure SetCallBackGetContactsList(approc:TmcGetContactsList);stdcall;
procedure SetCallBackGetChannelUsersList(approc:TmcGetChannelUsersList);stdcall;
procedure SetCallBackGetChannelsList(approc:TmcGetChannelsList);stdcall;
procedure SetCallBackGetActivePrivate(approc:TmcGetActivePrivate);stdcall;
procedure SetCallBackGetActiveChannel(approc:TmcGetActiveChannel);stdcall;
procedure SetCallBackClearTextChannel(approc:TmcClearTextChannel);stdcall;
procedure SetCallBackClearTextPrivate(approc:TmcClearTextPrivate);stdcall;
procedure SetCallBackConsoleCommand(approc:TmcConsoleCommand);stdcall;
procedure SetCallBackLoadOptions(approc:TmcLoadOptions);stdcall;
procedure SetCallBackGetUserQuickInfo(approc:TmcGetUserQuickInfo);stdcall;
procedure SetCallBackGetUserFullInfo(approc:TmcGetUserFullInfo);stdcall;
procedure SetCallBackIsTextChannelOpen(approc:TmcIsTextChannelOpen);stdcall;
procedure SetCallBackIsPrivateOpen(approc:TmcIsPrivateOpen);stdcall;
procedure SetCallBackGetChannelName(approc:TmcGetChannelName);stdcall;
procedure SetCallBackGetMyStatus(approc:TmcGetMyStatus);stdcall;
procedure SetCallBackIsConnected(approc:TmcIsConnected);stdcall;
procedure SetCallBackGetSmileCode(approc:TmcGetSmileCode);stdcall;
procedure SetCallBackSelectChannel(approc:TmcSelectChannel);stdcall;
procedure SetCallBackSelectPrivate(approc:TmcSelectPrivate);stdcall;
procedure SetCallBackSelectConsole(approc:TmcSelectConsole);stdcall;
procedure SetCallBackIsPluginLoaded(approc:TmcIsPluginLoaded);stdcall;
procedure SetCallBackGetUserActiveCaption(approc:TmcGetUserActiveCaption);stdcall;

implementation
uses mcplugin_info;

function get_next_st(var st_parse:string;divide_st:string):string;
var tmp:string;
begin
  if pos(divide_st,st_parse)<>0 then begin
    tmp:=copy(st_parse,1,pos(divide_st,st_parse)-1);
    delete(st_parse,1,pos(divide_st,st_parse)-1+length(divide_st));
  end
  else begin tmp:=st_parse;st_parse:='';end;
  result:=tmp;
end;{get_next_st}

function mcPluginName:PChar;
begin
  Result:=pluginName;
end;

function mcPluginCopyright:PChar;
begin
  Result:=pluginCopyright;
end;

procedure mcPluginAPIVersionUsed(var vmajor, vminor:dword);
begin
  vmajor:=pluginAPIVersionMajor;
  vminor:=pluginAPIVersionMinor;
end;

function mcPluginVersion:PChar;
begin
  Result:=pluginVersion;
end;

function mcPluginReleaseDate:PChar;
begin
  Result:=pluginReleaseDate;
end;

function mcPluginIsOptionsPresent:dword;
begin
  Result:=pluginOptionsPresent;
end;

function mcPluginIsWindowPresent:dword;
begin
  Result:=pluginWindowPresent;
end;

function mcPluginIsPopupMenuContactsPanelPresent:dword;stdcall;
begin
  Result:=pluginPopupMenuContactsPanel;
end;

function mcPluginIsPopupMenuUserInChannelTextPresent:dword;stdcall;
begin
  Result:=pluginPopupMenuUserInChannelText;
end;

function mcPluginIsPopupMenuUserInChannelUsersListPresent:dword;stdcall;
begin
  Result:=pluginPopupMenuUserInChannelUsersList;
end;

function mcPluginIsPopupMenuPrivatePresent:dword;stdcall;
begin
  Result:=pluginPopupMenuPrivate;
end;

function mcPluginIsTopMenuPrivatePresent:dword;stdcall;
begin
  Result:=pluginTopMenuPrivate;
end;

function mcPluginWWW:PChar;
begin
  Result:=pluginWWW;
end;

function mcPluginEmail:PChar;
begin
  Result:=pluginEmail;
end;

function mcPluginDescription:PChar;
begin
  Result:=pluginDescription;
end;

function mcPluginHookChannelMessages:dword;stdcall;
begin
  Result:=pluginHookChannelMessages;
end;

function mcPluginHookPrivateMessages:dword;stdcall;
begin
  Result:=pluginHookPrivateMessages;
end;

function mcPluginHookPersonalMessages:dword;stdcall;
begin
  Result:=pluginHookPersonalMessages;
end;

function mcPluginHookAlertMessages:dword;stdcall;
begin
  Result:=pluginHookAlertMessages;
end;

procedure SetCallBackSendMessageToTextChannel(approc:TmcSendMessageToTextChannel);
begin
  mcSendMessageToTextChannel:=approc;
end;

procedure SetCallBackSendPrivateMessage(approc:TmcSendPrivateMessage);
begin
  mcSendPrivateMessage:=approc;
end;

procedure SetCallBackSendPersonalMessage(approc:TmcSendPersonalMessage);
begin
  mcSendPersonalMessage:=approc;
end;

procedure SetCallBackSendAlertMessage(approc:TmcSendAlertMessage);
begin
  mcSendAlertMessage:=approc;
end;

procedure SetCallBackChangeTextChannelTopic(approc:TmcChangeTextChannelTopic);
begin
  mcChangeTextChannelTopic:=approc;
end;

procedure SetCallBackAdmBanUser(approc:TmcAdmBanUser);
begin
  mcAdmBanUser:=approc;
end;

procedure SetCallBackAdmKickUser(approc:TmcAdmKickUser);
begin
  mcAdmKickUser:=approc;
end;

procedure SetCallBackAdmKillUser(approc:TmcAdmKillUser);
begin
  mcAdmKillUser:=approc;
end;

procedure SetCallBackAdmBlockIP(approc:TmcAdmBlockIP);
begin
  mcAdmBlockIP:=approc;
end;

procedure SetCallBackAdmBlockMAC(approc:TmcAdmBlockMAC);
begin
  mcAdmBlockMAC:=approc;
end;

procedure SetCallBackSendRawData(approc:TmcSendRawData);
begin
  mcSendRawData:=approc;
end;

procedure SetCallBackSendRawDataToChannel(approc:TmcSendRawDataToChannel);
begin
  mcSendRawDataToChannel:=approc;
end;

procedure SetCallBackGetContactsList(approc:TmcGetContactsList);
begin
  mcGetContactsList:=approc;
end;

procedure SetCallBackGetChannelUsersList(approc:TmcGetChannelUsersList);
begin
  mcGetChannelUsersList:=approc;
end;

procedure SetCallBackGetChannelsList(approc:TmcGetChannelsList);
begin
  mcGetChannelsList:=approc;
end;

procedure SetCallBackGetActivePrivate(approc:TmcGetActivePrivate);
begin
  mcGetAtivePrivate:=approc;
end;

procedure SetCallBackGetActiveChannel(approc:TmcGetActiveChannel);
begin
  mcGetActiveChannel:=approc;
end;

procedure SetCallBackClearTextChannel(approc:TmcClearTextChannel);
begin
  mcClearTextChannel:=approc;
end;

procedure SetCallBackClearTextPrivate(approc:TmcClearTextPrivate);
begin
  mcClearTextPrivate:=approc;
end;

procedure SetCallBackConsoleCommand(approc:TmcConsoleCommand);
begin
  mcConsoleCommand:=approc;
end;

procedure SetCallBackLoadOptions(approc:TmcLoadOptions);
begin
  mcLoadOptions:=approc;
end;

procedure SetCallBackGetUserQuickInfo(approc:TmcGetUserQuickInfo);
begin
  mcGetUserQuickInfo:=approc;
end;

procedure SetCallBackGetUserFullInfo(approc:TmcGetUserFullInfo);
begin
  mcGetUserFullInfo:=approc;
end;

procedure SetCallBackIsTextChannelOpen(approc:TmcIsTextChannelOpen);
begin
  mcIsTextChannelOpen:=approc;
end;

procedure SetCallBackIsPrivateOpen(approc:TmcIsPrivateOpen);
begin
  mcIsPrivateOpen:=approc;
end;

procedure SetCallBackGetChannelName(approc:TmcGetChannelName);
begin
  mcGetChannelName:=approc;
end;

procedure SetCallBackGetMyStatus(approc:TmcGetMyStatus);
begin
  mcGetMyStatus:=approc;
end;

procedure SetCallBackIsConnected(approc:TmcIsConnected);
begin
  mcIsConnected:=approc;
end;

procedure SetCallBackGetSmileCode(approc:TmcGetSmileCode);
begin
  mcGetSmileCode:=approc;
end;

procedure SetCallBackSelectChannel(approc:TmcSelectChannel);
begin
  mcSelectChannel:=approc;
end;

procedure SetCallBackSelectPrivate(approc:TmcSelectPrivate);
begin
  mcSelectPrivate:=approc;
end;

procedure SetCallBackSelectConsole(approc:TmcSelectConsole);
begin
  mcSelectConsole:=approc;
end;

procedure SetCallBackIsPluginLoaded(approc:TmcIsPluginLoaded);
begin
  mcIsPluginLoaded:=approc;
end;

procedure SetCallBackGetUserActiveCaption(approc:TmcGetUserActiveCaption);
begin
  mcGetUserActiveCaption:=approc;
end;

exports
  mcPluginName,
  mcPluginCopyright,
  mcPluginAPIVersionUsed,
  mcPluginVersion,
  mcPluginReleaseDate,
  mcPluginIsOptionsPresent,
  mcPluginIsWindowPresent,
  mcPluginIsPopupMenuContactsPanelPresent,
  mcPluginIsPopupMenuUserInChannelTextPresent,
  mcPluginIsPopupMenuUserInChannelUsersListPresent,
  mcPluginIsPopupMenuPrivatePresent,
  mcPluginIsTopMenuPrivatePresent,
  mcPluginWWW,
  mcPluginEmail,
  mcPluginDescription,
  mcPluginCopyright,
  mcPluginHookChannelMessages,
  mcPluginHookPrivateMessages,
  mcPluginHookPersonalMessages,
  mcPluginHookAlertMessages,
  SetCallBackSendMessageToTextChannel,
  SetCallBackSendPrivateMessage,
  SetCallBackSendPersonalMessage,
  SetCallBackSendAlertMessage,
  SetCallBackChangeTextChannelTopic,
  SetCallBackAdmBanUser,
  SetCallBackAdmKickUser,
  SetCallBackAdmKillUser,
  SetCallBackAdmBlockIP,
  SetCallBackAdmBlockMAC,
  SetCallBackSendRawData,
  SetCallBackSendRawDataToChannel,
  SetCallBackGetContactsList,
  SetCallBackGetChannelUsersList,
  SetCallBackGetChannelsList,
  SetCallBackGetActivePrivate,
  SetCallBackGetActiveChannel,
  SetCallBackClearTextChannel,
  SetCallBackClearTextPrivate,
  SetCallBackConsoleCommand,
  SetCallBackLoadOptions,
  SetCallBackGetUserQuickInfo,
  SetCallBackGetUserFullInfo,
  SetCallBackIsTextChannelOpen,
  SetCallBackIsPrivateOpen,
  SetCallBackGetChannelName,
  SetCallBackGetMyStatus,
  SetCallBackIsConnected,
  SetCallBackGetSmileCode,
  SetCallBackSelectChannel,
  SetCallBackSelectPrivate,
  SetCallBackSelectConsole,
  SetCallBackIsPluginLoaded,
  SetCallBackGetUserActiveCaption;
end.
